'==========================================================================
'
' VBScript Source File -- Created with SAPIEN Technologies PrimalScript 2007
'
' NAME: CH340.VBS
'
' AUTHOR: Nico , GV
' DATE  : 3-11-2015
'
' COMMENT: Installing CH340 USB drivers for Arduino and retreive the used COM port
'			Load the servodecoder software and start Arduino IDE
'==========================================================================

Const HKEY_LOCAL_MACHINE = &H80000002
Const MAXCNT=300
Dim ke, pa, pad, KeyVal, Port, strKeyPath, return, Found, ID, Cmd, txt, Cnt
Set objShell = CreateObject("WScript.Shell")
Set objReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")

On Error Resume Next

Port=objShell.RegRead ("HKCU\Software\SimonTatham\PuTTY\Sessions\Arduino\SerialLine")
If Port="<COM>" Or Port="" Then 
	Port=GetCom()
	If Port="" Then	WScript.quit

	txt="Arduino USB driver correctly installed on port " & Port & VbCrLf
	txt=txt & VbCrLf & "After clicking OK the ASAR sketch will be loaded on your Arduino."
	txt=txt & VbCrLf & "Please wait. This may take some time"
	MsgBox txt,4096+32,"ASAR USB" 
	
	'Now loading servo decoder
	objShell.RegWrite "HKCU\Software\SimonTatham\PuTTY\Sessions\Arduino\SerialLine",port,"REG_SZ"
'	objShell.RegWrite "HKCU\Software\SimonTatham\PuTTY\Sessions\Arduino\WinTitle","ASAR, the Analog Servo controller with ARduino on " & port,"REG_SZ"
	
	Cmd="Arduino_debug.exe --upload --board arduino:avr:uno --port " & Port & " --save-prefs .\ASAR\ASAR.ino"
	return = objShell.Run (Cmd ,1,True)
	If return>0 Then
		MsgBox "Uploading the software has failed; error: " & CStr(return), 4096+16,"ASAR decoder"
		WScript.Quit
	End If
	MsgBox "The ASAR software is installed succesfully on your Arduino!",4096+64,"ASAR decoder"
End If

'Now starting Putty
Set Fso = CreateObject("Scripting.FileSystemObject")
Logpad=objShell.SpecialFolders("MyDocuments") & "\Arduino\ASAR\ASAR"
strLog = Logpad & ".log"
'If Fso.FileExists(strLog) Then Fso.DeleteFile strLog
objShell.RegWrite "HKCU\Software\SimonTatham\PuTTY\Sessions\Arduino\WinTitle","ASAR, the Analog Servo controller with ARduino on " & port,"REG_SZ"
Cmd="Putty.exe -load Arduino"
objShell.Run Cmd ,1,True
If Fso.FileExists(strLog) Then
    strLogN = Logpad & "_" & Date & "_" & Hour(Time) & "h" & Minute(Time) & "m.log"
	Fso.MoveFile strLog,strLogN
End If
Set Fso = Nothing
Set objShell = Nothing	
WScript.Quit

Function GetCom()
	keyPath = "HARDWARE\DEVICEMAP\SERIALCOMM"
	const HKLM = &H80000002
	Set objReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")
	voor=0
	If objreg.enumValues(HKLM, keyPath, valueNamesVoor, types) = 0 Then
		If isArray(valueNamesVoor) Then voor=UBound(valueNamesVoor)+1 
	End If
	txt="Please plug in the USB cable and click OK when done." & VbCrLf
	txt=txt & VbCrLf & "The driver software will then be installed."
	txt=txt & VbCrLf & "Please wait. This may take some time"
	MsgBox txt,4096+32,"ASAR USB"
	Cnt=0
	Na=0
	Do 				'Wait Until comport Is added
		WScript.Sleep 1000
		If objreg.enumValues(HKLM, keyPath, valueNamesNa, types) = 0 Then
			If isArray(valueNamesNa) Then Na=UBound(valueNamesNa)+1 
		End If
		If na<=voor Then	'nog geen nieuwe erbij
			Cnt=Cnt+1
			If Cnt>200 Then
				MsgBox "Time out when installing drivers; installation aborted!",4096+16,"ASAR USB"
				WScript.quit
			End If
		End If
	Loop Until na > voor	
	
	nw=0				'Which one is new?
	If na>1 Then
		For i=0 To Na-1
			Fnd=False
			For j=0 To Voor-1
				If valueNamesVoor(j) = valueNamesNa(i) Then Fnd=True
			Next
			If Not Fnd Then nw=i
		Next
	End If
	objreg.getStringValue HKLM, keyPath, valueNamesNa(nw), Port

	If Port="" Then
		MsgBox "Unknown error when installing drivers",4096+16,"ASAR USB"
	End If
	Set objReg=Nothing
	GetCom=Port
End Function