'==========================================================================
'
' VBScript Source File -- Created with SAPIEN Technologies PrimalScript 2007
'
' NAME: IASD.VBS
'
' AUTHOR: Nico , GV
' DATE  : 29/2/2016
'
' COMMENT: Installing CH340 USB drivers for Arduino and retreive the used COM port
'			Load the servodecoder software and start Arduino IDE
'==========================================================================

Const HKEY_LOCAL_MACHINE = &H80000002

Set objShell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")

ID=objShell.RegRead("HKLM\SOFTWARE\Wow6432Node\Arduino\Install_Dir")
If ID="" Then objShell.RegRead("HKLM\SOFTWARE\Arduino\Install_Dir")
If ID="" Then
	Magbox "Arduino IDE software not properly installed",4096+16,"Arduino IDE"
	wscript.quit
End If

If Not fso.FileExists ("Arduino.exe") Then
	MsgBox "Arduino.exe not found! Please unzip to folder where Arduino.exe is located.", 4096+16,"Arduino IDE"
	WScript.Quit
End If
On Error Resume Next

'Move files
FF=objShell.ExpandEnvironmentStrings("%WINDIR%") & "\Fonts\LucidaTypewriterRegular.ttf"
If Not fso.FileExists (FF) Then
	CurrentDirectory = fso.GetAbsolutePathName(".")
	Set objApp = CreateObject("Shell.Application")
	Set objNameSpace = objApp.Namespace(CurrentDirectory)
	Set objFont = objNameSpace.ParseName("LucidaTypewriterRegular.ttf")
	objFont.InvokeVerb("Install")
End if
fso.movefolder "CH340", ".\drivers\"
objShell.Run "regedit.exe /s ArduinoPutty.reg",7,True

'Create shortcuts
strPF = objShell.SpecialFolders("AllUsersStartMenu") & "\Programs\ASAR"
Set f = fso.CreateFolder(strPF)

strDesktop = objShell.SpecialFolders("AllusersDesktop")
Set oShellLink = objShell.CreateShortcut(strDesktop & "\Configure ASAR.lnk")
 oShellLink.TargetPath = ID & "\ChkCom.vbs"
 oShellLink.WindowStyle = 1
 oShellLink.IconLocation = ID & "\putty.exe, 1"
 oShellLink.WorkingDirectory = ID
 oShellLink.Save

Set oShellLink = objShell.CreateShortcut(strPF & "\Configure ASAR.lnk")
 oShellLink.TargetPath = ID & "\ChkCom.vbs"
 oShellLink.WindowStyle = 1
 oShellLink.IconLocation = ID & "\putty.exe, 1"
 oShellLink.WorkingDirectory = ID
 oShellLink.Save
 
Set oShellLink = objShell.CreateShortcut(strDesktop & "\ASAR Manual.lnk")
 oShellLink.TargetPath = ID & "\ASARmanual.pdf"
 oShellLink.WindowStyle = 1
 oShellLink.WorkingDirectory = ID
 oShellLink.Save

Set oShellLink = objShell.CreateShortcut(strPF & "\ASAR Manual.lnk")
 oShellLink.TargetPath = ID & "\ASARmanual.pdf"
 oShellLink.WindowStyle = 1
 oShellLink.WorkingDirectory = ID
 oShellLink.Save
  
Set oShellLink = objShell.CreateShortcut(strPF & "\Upload ASAR.lnk")
 oShellLink.TargetPath = ID & "\upload.vbs"
 oShellLink.WindowStyle = 1
 oShellLink.IconLocation =ID & "\putty.exe, 0"
 oShellLink.WorkingDirectory = ID
 oShellLink.Save

Set oShellLink = objShell.CreateShortcut(strPF & "\Settings for configuration.lnk")
 oShellLink.TargetPath = ID & "\putty.exe"
 oShellLink.WindowStyle = 1
 oShellLink.IconLocation =ID & "\putty.exe, 0"
 oShellLink.WorkingDirectory = ID
 oShellLink.Save
 
If MsgBox("Do you want to install the CH340 drivers for Chinese Arduino's?",vbYesNo+4096,"CH340 drivers") = vbYes Then
	Set WshProcEnv = objShell.Environment("Process")
	pa= WshProcEnv("PROCESSOR_ARCHITEW6432")  
	If pa = "" Then pa=WshProcEnv("PROCESSOR_ARCHITECTURE")
	pad = """" & ID & "\drivers\CH340\dpinst-" & pa & ".exe"""
	return = objShell.Run (pad & " /q",2,True)		'Install driver
	If return <> 256 Then
	    MsgBox "May be there is an error when installing drivers! Error: " & CStr(return),4096+16,"CH340 drivers"
	Else
		Port=GetCom()
	End If
	Set WshProcEnv = Nothing
Else
	PortOK=False
	While PortOK=False
	  	Port=InputBox ("Please specify the COM-poort for the Arduino serial connection (COMxx): ")
	  	Port=Ucase(Port)
		If Len(Port)>3 And Left(Port,3) = "COM" Then PortOK=True
	Wend
End If
objShell.RegWrite "HKCU\Software\SimonTatham\PuTTY\Sessions\Arduino\SerialLine",Port,"REG_SZ"
objShell.RegWrite "HKCU\Software\SimonTatham\PuTTY\Sessions\Arduino\WinTitle","ASAR, the Analog Servo controller with ARduino on " & port,"REG_SZ"
strlog = objShell.SpecialFolders("Mydocuments") & "\Arduino\ASAR\ASAR.log"
objShell.RegWrite "HKCU\Software\SimonTatham\PuTTY\Sessions\Arduino\LogFileName",strlog,"REG_SZ"

txt="Make sure your Arduino is connected via USB on port "& Port
txt=txt+VbCrLf+"The ASAR program will now be uploaded to your Arduino."
MsgBox txt, 4096+vbOKOnly,"ASAR"

Cmd="Arduino_debug.exe --upload --board arduino:avr:uno --port " & Port & " --save-prefs .\ASAR\ASAR.ino"
return = objShell.Run (Cmd ,1,True)
If return>0 Then
	MsgBox "Uploading the ASAR software has failed; error: " & CStr(return), 4096+16,"ASAR decoder"
	WScript.Quit
End If
txt="The ASAR software is succesfully installed on your Arduino"
txt=txt+VbCrLf+"Click OK to start the configuration"
MsgBox txt,4096+32,"ASAR decoder"

Logpad=objShell.SpecialFolders("MyDocuments") & "\Arduino\ASAR\ASAR"
Set f = fso.CreateFolder(Logpad)
strLog = Logpad & ".log"
Cmd="Putty.exe -load Arduino"
objShell.Run Cmd ,1,True

If Fso.FileExists(strLog) Then
    strLogN = Logpad & "_" & Date & "_" & Hour(Time) & "h" & Minute(Time) & "m.log"
	Fso.MoveFile strLog,strLogN
End If
Set Fso = Nothing
Set objShell = Nothing	

WScript.Quit

Function GetCom()
	keyPath = "HARDWARE\DEVICEMAP\SERIALCOMM"
	const HKLM = &H80000002
	Set objReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")
	voor=0
	If objreg.enumValues(HKLM, keyPath, valueNamesVoor, types) = 0 Then
		If isArray(valueNamesVoor) Then voor=UBound(valueNamesVoor)+1 
	End If
	txt="Please plug in the USB cable and click OK when done." & VbCrLf
	txt=txt & VbCrLf & "The driver software will then be installed."
	txt=txt & VbCrLf & "Please wait. This may take some time"
	MsgBox txt,4096+32,"ASAR USB"
	Cnt=0
	Na=0
	Do 				'Wait Until comport Is added
		WScript.Sleep 1000
		If objreg.enumValues(HKLM, keyPath, valueNamesNa, types) = 0 Then
			If isArray(valueNamesNa) Then Na=UBound(valueNamesNa)+1 
		End If
		If na<=voor Then	'nog geen nieuwe erbij
			Cnt=Cnt+1
			If Cnt>200 Then
				MsgBox "Time out when installing drivers; installation aborted!",4096+16,"ASAR USB"
				WScript.quit
			End If
		End If
	Loop Until na > voor	
	
	nw=0				'Which one is new?
	If na>1 Then
		For i=0 To Na-1
			Fnd=False
			For j=0 To Voor-1
				If valueNamesVoor(j) = valueNamesNa(i) Then Fnd=True
			Next
			If Not Fnd Then nw=i
		Next
	End If
	objreg.getStringValue HKLM, keyPath, valueNamesNa(nw), Port

	If Port="" Then
		MsgBox "Unknown error when installing drivers",4096+16,"ASAR USB"
	End If
	Set objReg=Nothing
	GetCom=Port
End Function